/* PairDialog.c generated by valac 0.56.17, the Vala compiler
 * generated from PairDialog.vala, do not modify */

/*-
 * Copyright (c) 2018 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "bluetooth.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <granite.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PAIR_DIALOG_0_PROPERTY,
	PAIR_DIALOG_OBJECT_PATH_PROPERTY,
	PAIR_DIALOG_AUTH_TYPE_PROPERTY,
	PAIR_DIALOG_PASSKEY_PROPERTY,
	PAIR_DIALOG_CANCELLED_PROPERTY,
	PAIR_DIALOG_NUM_PROPERTIES
};
static GParamSpec* pair_dialog_properties[PAIR_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PairDialogPrivate {
	char* _object_path;
	PairDialogAuthType _auth_type;
	gchar* _passkey;
	gboolean _cancelled;
};

static gint PairDialog_private_offset;
static gpointer pair_dialog_parent_class = NULL;

static PairDialog* pair_dialog_new (void);
static PairDialog* pair_dialog_construct (GType object_type);
static GObject * pair_dialog_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void pair_dialog_finalize (GObject * obj);
static GType pair_dialog_get_type_once (void);
static void _vala_pair_dialog_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_pair_dialog_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
pair_dialog_get_instance_private (PairDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PairDialog_private_offset);
}

static GType
pair_dialog_auth_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION, "PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION", "request-confirmation"}, {PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION, "PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION", "request-authorization"}, {PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY, "PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY", "display-passkey"}, {PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE, "PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE", "display-pin-code"}, {0, NULL, NULL}};
	GType pair_dialog_auth_type_type_id;
	pair_dialog_auth_type_type_id = g_enum_register_static ("PairDialogAuthType", values);
	return pair_dialog_auth_type_type_id;
}

GType
pair_dialog_auth_type_get_type (void)
{
	static volatile gsize pair_dialog_auth_type_type_id__once = 0;
	if (g_once_init_enter (&pair_dialog_auth_type_type_id__once)) {
		GType pair_dialog_auth_type_type_id;
		pair_dialog_auth_type_type_id = pair_dialog_auth_type_get_type_once ();
		g_once_init_leave (&pair_dialog_auth_type_type_id__once, pair_dialog_auth_type_type_id);
	}
	return pair_dialog_auth_type_type_id__once;
}

static PairDialog*
pair_dialog_construct (GType object_type)
{
	PairDialog * self = NULL;
#line 33 "../src/PairDialog.vala"
	self = (PairDialog*) g_object_new (object_type, "buttons", GTK_BUTTONS_CANCEL, NULL);
#line 32 "../src/PairDialog.vala"
	return self;
#line 115 "PairDialog.c"
}

static PairDialog*
pair_dialog_new (void)
{
#line 32 "../src/PairDialog.vala"
	return pair_dialog_construct (TYPE_PAIR_DIALOG);
#line 123 "PairDialog.c"
}

PairDialog*
pair_dialog_construct_request_authorization (GType object_type,
                                             const char* object_path,
                                             GtkWindow* main_window)
{
	PairDialog * self = NULL;
#line 38 "../src/PairDialog.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 39 "../src/PairDialog.vala"
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION, "buttons", GTK_BUTTONS_CANCEL, "object-path", object_path, "primary-text", _ ("Confirm Bluetooth Pairing"), "transient-for", main_window, NULL);
#line 38 "../src/PairDialog.vala"
	return self;
#line 138 "PairDialog.c"
}

PairDialog*
pair_dialog_new_request_authorization (const char* object_path,
                                       GtkWindow* main_window)
{
#line 38 "../src/PairDialog.vala"
	return pair_dialog_construct_request_authorization (TYPE_PAIR_DIALOG, object_path, main_window);
#line 147 "PairDialog.c"
}

PairDialog*
pair_dialog_construct_display_passkey (GType object_type,
                                       const char* object_path,
                                       guint32 passkey,
                                       guint16 entered,
                                       GtkWindow* main_window)
{
	PairDialog * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 48 "../src/PairDialog.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 49 "../src/PairDialog.vala"
	_tmp0_ = g_strdup_printf ("%u", (guint) passkey);
#line 49 "../src/PairDialog.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/PairDialog.vala"
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY, "buttons", GTK_BUTTONS_CANCEL, "object-path", object_path, "passkey", _tmp1_, "primary-text", _ ("Confirm Bluetooth Passkey"), "transient-for", main_window, NULL);
#line 49 "../src/PairDialog.vala"
	_g_free0 (_tmp1_);
#line 48 "../src/PairDialog.vala"
	return self;
#line 172 "PairDialog.c"
}

PairDialog*
pair_dialog_new_display_passkey (const char* object_path,
                                 guint32 passkey,
                                 guint16 entered,
                                 GtkWindow* main_window)
{
#line 48 "../src/PairDialog.vala"
	return pair_dialog_construct_display_passkey (TYPE_PAIR_DIALOG, object_path, passkey, entered, main_window);
#line 183 "PairDialog.c"
}

PairDialog*
pair_dialog_construct_request_confirmation (GType object_type,
                                            const char* object_path,
                                            guint32 passkey,
                                            GtkWindow* main_window)
{
	PairDialog * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 59 "../src/PairDialog.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 60 "../src/PairDialog.vala"
	_tmp0_ = g_strdup_printf ("%u", (guint) passkey);
#line 60 "../src/PairDialog.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/PairDialog.vala"
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION, "buttons", GTK_BUTTONS_CANCEL, "object-path", object_path, "passkey", _tmp1_, "primary-text", _ ("Confirm Bluetooth Passkey"), "transient-for", main_window, NULL);
#line 60 "../src/PairDialog.vala"
	_g_free0 (_tmp1_);
#line 59 "../src/PairDialog.vala"
	return self;
#line 207 "PairDialog.c"
}

PairDialog*
pair_dialog_new_request_confirmation (const char* object_path,
                                      guint32 passkey,
                                      GtkWindow* main_window)
{
#line 59 "../src/PairDialog.vala"
	return pair_dialog_construct_request_confirmation (TYPE_PAIR_DIALOG, object_path, passkey, main_window);
#line 217 "PairDialog.c"
}

PairDialog*
pair_dialog_construct_display_pin_code (GType object_type,
                                        const char* object_path,
                                        const gchar* pincode,
                                        GtkWindow* main_window)
{
	PairDialog * self = NULL;
#line 70 "../src/PairDialog.vala"
	g_return_val_if_fail (object_path != NULL, NULL);
#line 70 "../src/PairDialog.vala"
	g_return_val_if_fail (pincode != NULL, NULL);
#line 71 "../src/PairDialog.vala"
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE, "buttons", GTK_BUTTONS_CANCEL, "object-path", object_path, "passkey", pincode, "primary-text", _ ("Enter Bluetooth PIN"), "transient-for", main_window, NULL);
#line 70 "../src/PairDialog.vala"
	return self;
#line 235 "PairDialog.c"
}

PairDialog*
pair_dialog_new_display_pin_code (const char* object_path,
                                  const gchar* pincode,
                                  GtkWindow* main_window)
{
#line 70 "../src/PairDialog.vala"
	return pair_dialog_construct_display_pin_code (TYPE_PAIR_DIALOG, object_path, pincode, main_window);
#line 245 "PairDialog.c"
}

const char*
pair_dialog_get_object_path (PairDialog* self)
{
	const char* result;
	const char* _tmp0_;
#line 26 "../src/PairDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/PairDialog.vala"
	_tmp0_ = self->priv->_object_path;
#line 26 "../src/PairDialog.vala"
	result = _tmp0_;
#line 26 "../src/PairDialog.vala"
	return result;
#line 261 "PairDialog.c"
}

static void
pair_dialog_set_object_path (PairDialog* self,
                             const char* value)
{
	char* old_value;
#line 26 "../src/PairDialog.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/PairDialog.vala"
	old_value = pair_dialog_get_object_path (self);
#line 26 "../src/PairDialog.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 275 "PairDialog.c"
		char* _tmp0_;
#line 26 "../src/PairDialog.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/PairDialog.vala"
		_g_free0 (self->priv->_object_path);
#line 26 "../src/PairDialog.vala"
		self->priv->_object_path = _tmp0_;
#line 26 "../src/PairDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_OBJECT_PATH_PROPERTY]);
#line 285 "PairDialog.c"
	}
}

PairDialogAuthType
pair_dialog_get_auth_type (PairDialog* self)
{
	PairDialogAuthType result;
#line 27 "../src/PairDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/PairDialog.vala"
	result = self->priv->_auth_type;
#line 27 "../src/PairDialog.vala"
	return result;
#line 299 "PairDialog.c"
}

static void
pair_dialog_set_auth_type (PairDialog* self,
                           PairDialogAuthType value)
{
	PairDialogAuthType old_value;
#line 27 "../src/PairDialog.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/PairDialog.vala"
	old_value = pair_dialog_get_auth_type (self);
#line 27 "../src/PairDialog.vala"
	if (old_value != value) {
#line 27 "../src/PairDialog.vala"
		self->priv->_auth_type = value;
#line 27 "../src/PairDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_AUTH_TYPE_PROPERTY]);
#line 317 "PairDialog.c"
	}
}

const gchar*
pair_dialog_get_passkey (PairDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/PairDialog.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/PairDialog.vala"
	_tmp0_ = self->priv->_passkey;
#line 28 "../src/PairDialog.vala"
	result = _tmp0_;
#line 28 "../src/PairDialog.vala"
	return result;
#line 334 "PairDialog.c"
}

static void
pair_dialog_set_passkey (PairDialog* self,
                         const gchar* value)
{
	gchar* old_value;
#line 28 "../src/PairDialog.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/PairDialog.vala"
	old_value = pair_dialog_get_passkey (self);
#line 28 "../src/PairDialog.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 348 "PairDialog.c"
		gchar* _tmp0_;
#line 28 "../src/PairDialog.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/PairDialog.vala"
		_g_free0 (self->priv->_passkey);
#line 28 "../src/PairDialog.vala"
		self->priv->_passkey = _tmp0_;
#line 28 "../src/PairDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_PASSKEY_PROPERTY]);
#line 358 "PairDialog.c"
	}
}

gboolean
pair_dialog_get_cancelled (PairDialog* self)
{
	gboolean result;
#line 29 "../src/PairDialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/PairDialog.vala"
	result = self->priv->_cancelled;
#line 29 "../src/PairDialog.vala"
	return result;
#line 372 "PairDialog.c"
}

void
pair_dialog_set_cancelled (PairDialog* self,
                           gboolean value)
{
	gboolean old_value;
#line 29 "../src/PairDialog.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/PairDialog.vala"
	old_value = pair_dialog_get_cancelled (self);
#line 29 "../src/PairDialog.vala"
	if (old_value != value) {
#line 29 "../src/PairDialog.vala"
		self->priv->_cancelled = value;
#line 29 "../src/PairDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_CANCELLED_PROPERTY]);
#line 390 "PairDialog.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../src/PairDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 399 "PairDialog.c"
}

static GObject *
pair_dialog_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PairDialog * self;
	BluetoothServicesDevice* device = NULL;
	gchar* device_name = NULL;
	gchar* _tmp0_;
	PairDialogAuthType _tmp24_;
	gboolean _tmp58_ = FALSE;
	const gchar* _tmp59_;
	GError* _inner_error0_ = NULL;
#line 81 "../src/PairDialog.vala"
	parent_class = G_OBJECT_CLASS (pair_dialog_parent_class);
#line 81 "../src/PairDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 81 "../src/PairDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAIR_DIALOG, PairDialog);
#line 83 "../src/PairDialog.vala"
	_tmp0_ = g_strdup (_ ("Unknown Bluetooth Device"));
#line 83 "../src/PairDialog.vala"
	device_name = _tmp0_;
#line 427 "PairDialog.c"
	{
		BluetoothServicesDevice* _tmp1_ = NULL;
		const char* _tmp2_;
		BluetoothServicesDevice* _tmp3_;
		BluetoothServicesDevice* _tmp4_;
		gchar* _tmp5_ = NULL;
		BluetoothServicesDevice* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GThemedIcon* _tmp10_;
		GThemedIcon* _tmp11_;
		gchar* _tmp12_ = NULL;
		BluetoothServicesDevice* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp19_;
#line 85 "../src/PairDialog.vala"
		_tmp2_ = self->priv->_object_path;
#line 85 "../src/PairDialog.vala"
		_tmp3_ = (BluetoothServicesDevice*) g_initable_new (BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", "org.bluez", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _tmp2_, "g-interface-name", "org.bluez.Device1", NULL);
#line 85 "../src/PairDialog.vala"
		_tmp1_ = (BluetoothServicesDevice*) _tmp3_;
#line 85 "../src/PairDialog.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 85 "../src/PairDialog.vala"
			if (_inner_error0_->domain == G_IO_ERROR) {
#line 454 "PairDialog.c"
				goto __catch0_g_io_error;
			}
#line 85 "../src/PairDialog.vala"
			_g_free0 (device_name);
#line 85 "../src/PairDialog.vala"
			_g_object_unref0 (device);
#line 85 "../src/PairDialog.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 85 "../src/PairDialog.vala"
			g_clear_error (&_inner_error0_);
#line 465 "PairDialog.c"
		}
#line 85 "../src/PairDialog.vala"
		_tmp4_ = _tmp1_;
#line 85 "../src/PairDialog.vala"
		_tmp1_ = NULL;
#line 85 "../src/PairDialog.vala"
		_g_object_unref0 (device);
#line 85 "../src/PairDialog.vala"
		device = _tmp4_;
#line 86 "../src/PairDialog.vala"
		_tmp6_ = device;
#line 86 "../src/PairDialog.vala"
		_tmp7_ = bluetooth_services_device_get_icon (_tmp6_);
#line 86 "../src/PairDialog.vala"
		_tmp8_ = _tmp7_;
#line 86 "../src/PairDialog.vala"
		_tmp5_ = _tmp8_;
#line 86 "../src/PairDialog.vala"
		if (_tmp5_ == NULL) {
#line 485 "PairDialog.c"
			gchar* _tmp9_;
#line 86 "../src/PairDialog.vala"
			_tmp9_ = g_strdup ("bluetooth");
#line 86 "../src/PairDialog.vala"
			_g_free0 (_tmp5_);
#line 86 "../src/PairDialog.vala"
			_tmp5_ = _tmp9_;
#line 493 "PairDialog.c"
		}
#line 86 "../src/PairDialog.vala"
		_tmp10_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 86 "../src/PairDialog.vala"
		_tmp11_ = _tmp10_;
#line 86 "../src/PairDialog.vala"
		granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp11_);
#line 86 "../src/PairDialog.vala"
		_g_object_unref0 (_tmp11_);
#line 87 "../src/PairDialog.vala"
		_tmp13_ = device;
#line 87 "../src/PairDialog.vala"
		_tmp14_ = bluetooth_services_device_get_name (_tmp13_);
#line 87 "../src/PairDialog.vala"
		_tmp15_ = _tmp14_;
#line 87 "../src/PairDialog.vala"
		_tmp12_ = _tmp15_;
#line 87 "../src/PairDialog.vala"
		if (_tmp12_ == NULL) {
#line 513 "PairDialog.c"
			BluetoothServicesDevice* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 87 "../src/PairDialog.vala"
			_tmp16_ = device;
#line 87 "../src/PairDialog.vala"
			_tmp17_ = bluetooth_services_device_get_address (_tmp16_);
#line 87 "../src/PairDialog.vala"
			_tmp18_ = _tmp17_;
#line 87 "../src/PairDialog.vala"
			_g_free0 (_tmp12_);
#line 87 "../src/PairDialog.vala"
			_tmp12_ = _tmp18_;
#line 527 "PairDialog.c"
		}
#line 87 "../src/PairDialog.vala"
		_tmp19_ = _tmp12_;
#line 87 "../src/PairDialog.vala"
		_tmp12_ = NULL;
#line 87 "../src/PairDialog.vala"
		_g_free0 (device_name);
#line 87 "../src/PairDialog.vala"
		device_name = _tmp19_;
#line 84 "../src/PairDialog.vala"
		_g_free0 (_tmp12_);
#line 84 "../src/PairDialog.vala"
		_g_free0 (_tmp5_);
#line 84 "../src/PairDialog.vala"
		_g_object_unref0 (_tmp1_);
#line 543 "PairDialog.c"
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GThemedIcon* _tmp20_;
		GThemedIcon* _tmp21_;
		GError* _tmp22_;
		const gchar* _tmp23_;
#line 84 "../src/PairDialog.vala"
		e = _inner_error0_;
#line 84 "../src/PairDialog.vala"
		_inner_error0_ = NULL;
#line 89 "../src/PairDialog.vala"
		_tmp20_ = (GThemedIcon*) g_themed_icon_new ("bluetooth");
#line 89 "../src/PairDialog.vala"
		_tmp21_ = _tmp20_;
#line 89 "../src/PairDialog.vala"
		granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp21_);
#line 89 "../src/PairDialog.vala"
		_g_object_unref0 (_tmp21_);
#line 90 "../src/PairDialog.vala"
		_tmp22_ = e;
#line 90 "../src/PairDialog.vala"
		_tmp23_ = _tmp22_->message;
#line 90 "../src/PairDialog.vala"
		g_critical ("PairDialog.vala:90: %s", _tmp23_);
#line 84 "../src/PairDialog.vala"
		_g_error_free0 (e);
#line 573 "PairDialog.c"
	}
	__finally0:
#line 84 "../src/PairDialog.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 84 "../src/PairDialog.vala"
		_g_free0 (device_name);
#line 84 "../src/PairDialog.vala"
		_g_object_unref0 (device);
#line 84 "../src/PairDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 84 "../src/PairDialog.vala"
		g_clear_error (&_inner_error0_);
#line 586 "PairDialog.c"
	}
#line 93 "../src/PairDialog.vala"
	_tmp24_ = self->priv->_auth_type;
#line 93 "../src/PairDialog.vala"
	switch (_tmp24_) {
#line 93 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION:
#line 594 "PairDialog.c"
		{
			GThemedIcon* _tmp25_;
			GThemedIcon* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			GtkWidget* confirm_button = NULL;
			GtkWidget* _tmp30_;
			GtkWidget* _tmp31_;
			GtkWidget* _tmp32_;
			GtkStyleContext* _tmp33_;
#line 95 "../src/PairDialog.vala"
			_tmp25_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 95 "../src/PairDialog.vala"
			_tmp26_ = _tmp25_;
#line 95 "../src/PairDialog.vala"
			granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp26_);
#line 95 "../src/PairDialog.vala"
			_g_object_unref0 (_tmp26_);
#line 96 "../src/PairDialog.vala"
			_tmp27_ = device_name;
#line 96 "../src/PairDialog.vala"
			_tmp28_ = g_strdup_printf (_ ("Make sure the code displayed on “%s” matches the one below."), _tmp27_);
#line 96 "../src/PairDialog.vala"
			_tmp29_ = _tmp28_;
#line 96 "../src/PairDialog.vala"
			granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp29_);
#line 96 "../src/PairDialog.vala"
			_g_free0 (_tmp29_);
#line 98 "../src/PairDialog.vala"
			_tmp30_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Pair"), (gint) GTK_RESPONSE_ACCEPT);
#line 98 "../src/PairDialog.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 98 "../src/PairDialog.vala"
			confirm_button = _tmp31_;
#line 99 "../src/PairDialog.vala"
			_tmp32_ = confirm_button;
#line 99 "../src/PairDialog.vala"
			_tmp33_ = gtk_widget_get_style_context (_tmp32_);
#line 99 "../src/PairDialog.vala"
			gtk_style_context_add_class (_tmp33_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 100 "../src/PairDialog.vala"
			_g_object_unref0 (confirm_button);
#line 100 "../src/PairDialog.vala"
			break;
#line 640 "PairDialog.c"
		}
#line 93 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY:
#line 644 "PairDialog.c"
		{
			GThemedIcon* _tmp34_;
			GThemedIcon* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			GtkWidget* confirm_button = NULL;
			GtkWidget* _tmp40_;
			GtkWidget* _tmp41_;
			GtkWidget* _tmp42_;
			GtkStyleContext* _tmp43_;
#line 102 "../src/PairDialog.vala"
			_tmp34_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 102 "../src/PairDialog.vala"
			_tmp35_ = _tmp34_;
#line 102 "../src/PairDialog.vala"
			granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp35_);
#line 102 "../src/PairDialog.vala"
			_g_object_unref0 (_tmp35_);
#line 103 "../src/PairDialog.vala"
			_tmp36_ = device_name;
#line 103 "../src/PairDialog.vala"
			_tmp37_ = device_name;
#line 103 "../src/PairDialog.vala"
			_tmp38_ = g_strdup_printf (_ ("“%s” would like to pair with this device. Make sure the code displayed" \
" on “%s” matches the one below."), _tmp36_, _tmp37_);
#line 103 "../src/PairDialog.vala"
			_tmp39_ = _tmp38_;
#line 103 "../src/PairDialog.vala"
			granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp39_);
#line 103 "../src/PairDialog.vala"
			_g_free0 (_tmp39_);
#line 105 "../src/PairDialog.vala"
			_tmp40_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Pair"), (gint) GTK_RESPONSE_ACCEPT);
#line 105 "../src/PairDialog.vala"
			_tmp41_ = _g_object_ref0 (_tmp40_);
#line 105 "../src/PairDialog.vala"
			confirm_button = _tmp41_;
#line 106 "../src/PairDialog.vala"
			_tmp42_ = confirm_button;
#line 106 "../src/PairDialog.vala"
			_tmp43_ = gtk_widget_get_style_context (_tmp42_);
#line 106 "../src/PairDialog.vala"
			gtk_style_context_add_class (_tmp43_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 107 "../src/PairDialog.vala"
			_g_object_unref0 (confirm_button);
#line 107 "../src/PairDialog.vala"
			break;
#line 693 "PairDialog.c"
		}
#line 93 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE:
#line 697 "PairDialog.c"
		{
			GThemedIcon* _tmp44_;
			GThemedIcon* _tmp45_;
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 109 "../src/PairDialog.vala"
			_tmp44_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 109 "../src/PairDialog.vala"
			_tmp45_ = _tmp44_;
#line 109 "../src/PairDialog.vala"
			granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp45_);
#line 109 "../src/PairDialog.vala"
			_g_object_unref0 (_tmp45_);
#line 110 "../src/PairDialog.vala"
			_tmp46_ = device_name;
#line 110 "../src/PairDialog.vala"
			_tmp47_ = g_strdup_printf (_ ("Type the code displayed below on “%s”, followed by Enter."), _tmp46_);
#line 110 "../src/PairDialog.vala"
			_tmp48_ = _tmp47_;
#line 110 "../src/PairDialog.vala"
			granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp48_);
#line 110 "../src/PairDialog.vala"
			_g_free0 (_tmp48_);
#line 111 "../src/PairDialog.vala"
			break;
#line 724 "PairDialog.c"
		}
#line 93 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION:
#line 728 "PairDialog.c"
		{
			GThemedIcon* _tmp49_;
			GThemedIcon* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			GtkWidget* confirm_button = NULL;
			GtkWidget* _tmp54_;
			GtkWidget* _tmp55_;
			GtkWidget* _tmp56_;
			GtkStyleContext* _tmp57_;
#line 113 "../src/PairDialog.vala"
			_tmp49_ = (GThemedIcon*) g_themed_icon_new ("dialog-question");
#line 113 "../src/PairDialog.vala"
			_tmp50_ = _tmp49_;
#line 113 "../src/PairDialog.vala"
			granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp50_);
#line 113 "../src/PairDialog.vala"
			_g_object_unref0 (_tmp50_);
#line 114 "../src/PairDialog.vala"
			_tmp51_ = device_name;
#line 114 "../src/PairDialog.vala"
			_tmp52_ = g_strdup_printf (_ ("“%s” would like to pair with this device."), _tmp51_);
#line 114 "../src/PairDialog.vala"
			_tmp53_ = _tmp52_;
#line 114 "../src/PairDialog.vala"
			granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, _tmp53_);
#line 114 "../src/PairDialog.vala"
			_g_free0 (_tmp53_);
#line 116 "../src/PairDialog.vala"
			_tmp54_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Pair"), (gint) GTK_RESPONSE_ACCEPT);
#line 116 "../src/PairDialog.vala"
			_tmp55_ = _g_object_ref0 (_tmp54_);
#line 116 "../src/PairDialog.vala"
			confirm_button = _tmp55_;
#line 117 "../src/PairDialog.vala"
			_tmp56_ = confirm_button;
#line 117 "../src/PairDialog.vala"
			_tmp57_ = gtk_widget_get_style_context (_tmp56_);
#line 117 "../src/PairDialog.vala"
			gtk_style_context_add_class (_tmp57_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 118 "../src/PairDialog.vala"
			_g_object_unref0 (confirm_button);
#line 118 "../src/PairDialog.vala"
			break;
#line 774 "PairDialog.c"
		}
		default:
#line 93 "../src/PairDialog.vala"
		break;
#line 779 "PairDialog.c"
	}
#line 121 "../src/PairDialog.vala"
	_tmp59_ = self->priv->_passkey;
#line 121 "../src/PairDialog.vala"
	if (_tmp59_ != NULL) {
#line 785 "PairDialog.c"
		const gchar* _tmp60_;
#line 121 "../src/PairDialog.vala"
		_tmp60_ = self->priv->_passkey;
#line 121 "../src/PairDialog.vala"
		_tmp58_ = g_strcmp0 (_tmp60_, "") != 0;
#line 791 "PairDialog.c"
	} else {
#line 121 "../src/PairDialog.vala"
		_tmp58_ = FALSE;
#line 795 "PairDialog.c"
	}
#line 121 "../src/PairDialog.vala"
	if (_tmp58_) {
#line 799 "PairDialog.c"
		GtkLabel* passkey_label = NULL;
		const gchar* _tmp61_;
		GtkLabel* _tmp62_;
		GtkLabel* _tmp63_;
		GtkStyleContext* _tmp64_;
		GtkBin* _tmp65_;
		GtkBin* _tmp66_;
		GtkLabel* _tmp67_;
		GtkBin* _tmp68_;
		GtkBin* _tmp69_;
#line 122 "../src/PairDialog.vala"
		_tmp61_ = self->priv->_passkey;
#line 122 "../src/PairDialog.vala"
		_tmp62_ = (GtkLabel*) gtk_label_new (_tmp61_);
#line 122 "../src/PairDialog.vala"
		g_object_ref_sink (_tmp62_);
#line 122 "../src/PairDialog.vala"
		passkey_label = _tmp62_;
#line 123 "../src/PairDialog.vala"
		_tmp63_ = passkey_label;
#line 123 "../src/PairDialog.vala"
		_tmp64_ = gtk_widget_get_style_context ((GtkWidget*) _tmp63_);
#line 123 "../src/PairDialog.vala"
		gtk_style_context_add_class (_tmp64_, GRANITE_STYLE_CLASS_H1_LABEL);
#line 125 "../src/PairDialog.vala"
		_tmp65_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 125 "../src/PairDialog.vala"
		_tmp66_ = _tmp65_;
#line 125 "../src/PairDialog.vala"
		_tmp67_ = passkey_label;
#line 125 "../src/PairDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp66_, (GtkWidget*) _tmp67_);
#line 126 "../src/PairDialog.vala"
		_tmp68_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 126 "../src/PairDialog.vala"
		_tmp69_ = _tmp68_;
#line 126 "../src/PairDialog.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp69_);
#line 121 "../src/PairDialog.vala"
		_g_object_unref0 (passkey_label);
#line 840 "PairDialog.c"
	}
#line 129 "../src/PairDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 81 "../src/PairDialog.vala"
	_g_free0 (device_name);
#line 81 "../src/PairDialog.vala"
	_g_object_unref0 (device);
#line 81 "../src/PairDialog.vala"
	return obj;
#line 850 "PairDialog.c"
}

static void
pair_dialog_class_init (PairDialogClass * klass,
                        gpointer klass_data)
{
#line 18 "../src/PairDialog.vala"
	pair_dialog_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/PairDialog.vala"
	g_type_class_adjust_private_offset (klass, &PairDialog_private_offset);
#line 18 "../src/PairDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_pair_dialog_get_property;
#line 18 "../src/PairDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_pair_dialog_set_property;
#line 18 "../src/PairDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = pair_dialog_constructor;
#line 18 "../src/PairDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = pair_dialog_finalize;
#line 18 "../src/PairDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_OBJECT_PATH_PROPERTY, pair_dialog_properties[PAIR_DIALOG_OBJECT_PATH_PROPERTY] = g_param_spec_string ("object-path", "object-path", "object-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/PairDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_AUTH_TYPE_PROPERTY, pair_dialog_properties[PAIR_DIALOG_AUTH_TYPE_PROPERTY] = g_param_spec_enum ("auth-type", "auth-type", "auth-type", PAIR_DIALOG_TYPE_AUTH_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/PairDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_PASSKEY_PROPERTY, pair_dialog_properties[PAIR_DIALOG_PASSKEY_PROPERTY] = g_param_spec_string ("passkey", "passkey", "passkey", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 18 "../src/PairDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_CANCELLED_PROPERTY, pair_dialog_properties[PAIR_DIALOG_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 877 "PairDialog.c"
}

static void
pair_dialog_instance_init (PairDialog * self,
                           gpointer klass)
{
#line 18 "../src/PairDialog.vala"
	self->priv = pair_dialog_get_instance_private (self);
#line 886 "PairDialog.c"
}

static void
pair_dialog_finalize (GObject * obj)
{
	PairDialog * self;
#line 18 "../src/PairDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAIR_DIALOG, PairDialog);
#line 26 "../src/PairDialog.vala"
	_g_free0 (self->priv->_object_path);
#line 28 "../src/PairDialog.vala"
	_g_free0 (self->priv->_passkey);
#line 18 "../src/PairDialog.vala"
	G_OBJECT_CLASS (pair_dialog_parent_class)->finalize (obj);
#line 901 "PairDialog.c"
}

static GType
pair_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PairDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pair_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PairDialog), 0, (GInstanceInitFunc) pair_dialog_instance_init, NULL };
	GType pair_dialog_type_id;
	pair_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "PairDialog", &g_define_type_info, 0);
	PairDialog_private_offset = g_type_add_instance_private (pair_dialog_type_id, sizeof (PairDialogPrivate));
	return pair_dialog_type_id;
}

GType
pair_dialog_get_type (void)
{
	static volatile gsize pair_dialog_type_id__once = 0;
	if (g_once_init_enter (&pair_dialog_type_id__once)) {
		GType pair_dialog_type_id;
		pair_dialog_type_id = pair_dialog_get_type_once ();
		g_once_init_leave (&pair_dialog_type_id__once, pair_dialog_type_id);
	}
	return pair_dialog_type_id__once;
}

static void
_vala_pair_dialog_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PairDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAIR_DIALOG, PairDialog);
#line 18 "../src/PairDialog.vala"
	switch (property_id) {
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_OBJECT_PATH_PROPERTY:
#line 18 "../src/PairDialog.vala"
		g_value_set_string (value, pair_dialog_get_object_path (self));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_PROPERTY:
#line 18 "../src/PairDialog.vala"
		g_value_set_enum (value, pair_dialog_get_auth_type (self));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_PASSKEY_PROPERTY:
#line 18 "../src/PairDialog.vala"
		g_value_set_string (value, pair_dialog_get_passkey (self));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_CANCELLED_PROPERTY:
#line 18 "../src/PairDialog.vala"
		g_value_set_boolean (value, pair_dialog_get_cancelled (self));
#line 18 "../src/PairDialog.vala"
		break;
#line 960 "PairDialog.c"
		default:
#line 18 "../src/PairDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/PairDialog.vala"
		break;
#line 966 "PairDialog.c"
	}
}

static void
_vala_pair_dialog_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PairDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAIR_DIALOG, PairDialog);
#line 18 "../src/PairDialog.vala"
	switch (property_id) {
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_OBJECT_PATH_PROPERTY:
#line 18 "../src/PairDialog.vala"
		pair_dialog_set_object_path (self, g_value_get_string (value));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_AUTH_TYPE_PROPERTY:
#line 18 "../src/PairDialog.vala"
		pair_dialog_set_auth_type (self, g_value_get_enum (value));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_PASSKEY_PROPERTY:
#line 18 "../src/PairDialog.vala"
		pair_dialog_set_passkey (self, g_value_get_string (value));
#line 18 "../src/PairDialog.vala"
		break;
#line 18 "../src/PairDialog.vala"
		case PAIR_DIALOG_CANCELLED_PROPERTY:
#line 18 "../src/PairDialog.vala"
		pair_dialog_set_cancelled (self, g_value_get_boolean (value));
#line 18 "../src/PairDialog.vala"
		break;
#line 1004 "PairDialog.c"
		default:
#line 18 "../src/PairDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/PairDialog.vala"
		break;
#line 1010 "PairDialog.c"
	}
}

